Index: trunk/SophyaPI/PIext/nobjmgr.cc
===================================================================
--- trunk/SophyaPI/PIext/nobjmgr.cc	(revision 1104)
+++ trunk/SophyaPI/PIext/nobjmgr.cc	(revision 1105)
@@ -21,6 +21,4 @@
 #ifdef SANS_EVOLPLANCK
 #include "fitsimage.h"  
-#else
-#include "fitsioserver.h"  
 #endif
 
@@ -855,38 +853,12 @@
 } ENDTRY;
 
-#else
-
- AnyDataObj * obj=NULL;
- FitsIoServer fios;
- char fitsfile[512];
- strncpy(fitsfile, flnm.c_str(), 512); fitsfile[511] = '\0';
- int hdu = 1;
- // Nous essayons de lire jusqu'a l'entete numero 3 
- while (hdu < 4) {
-   try {
-     cout << "NamedObjMgr::ReadFITS() - Trying to read " << flnm 
-	  << " HDU= " << hdu << endl;
-     obj = fios.loadobj(fitsfile, hdu);
-     if(obj) {
-       ok = true;
-       hdu = 9999;
-     }
-   }
-   catch(IOExc exc) {
-     cerr << "NamedObjMgr::ReadFITS() - IOExc " << exc.Msg() << endl;
-     hdu++;
-   }
-   catch(...) {
-     cerr << "NamedObjMgr::ReadFITS() - Error reading " << flnm << endl;
-     hdu++;
-     //     ok = false;
-     // hdu = 99999;
-   }
- }
-#endif
 if (ok && (obj != NULL)) { 
   if (nobj.length()<1)  nobj = servnobjm->FileName2Name(flnm);
   AddObj((AnyDataObj*)obj, nobj);
 }
+#else
+ cerr << " NamedObjMgr::ReadFits() Vide ! A faire Reza ! " << endl;
+#endif
+
 return;
 }
Index: trunk/SophyaPI/PIext/nomimagadapter.cc
===================================================================
--- trunk/SophyaPI/PIext/nomimagadapter.cc	(revision 1104)
+++ trunk/SophyaPI/PIext/nomimagadapter.cc	(revision 1105)
@@ -162,21 +162,25 @@
 #ifdef __CXX_PRAGMA_TEMPLATES__
 #pragma define_template NOMAdapter_Image<uint_2>
-#pragma define_template NOMAdapter_Image<int_2>
 #pragma define_template NOMAdapter_Image<int_4>
 #pragma define_template NOMAdapter_Image<r_4>
 #pragma define_template NTupInt_Image<uint_2>
-#pragma define_template NTupInt_Image<int_2>
 #pragma define_template NTupInt_Image<int_4>
 #pragma define_template NTupInt_Image<r_4>
+#ifdef SANS_EVOLPLANCK
+#pragma define_template NOMAdapter_Image<int_2>
+#pragma define_template NTupInt_Image<int_2>
+#endif
 #endif
 #if defined(ANSI_TEMPLATES) || defined(__ANSI_TEMPLATES__) || defined(__GNU_TEMPLATES__) 
 template class NOMAdapter_Image<uint_2>;
-template class NOMAdapter_Image<int_2>;
 template class NOMAdapter_Image<int_4>;
 template class NOMAdapter_Image<r_4>;
 template class NTupInt_Image<uint_2>;
-template class NTupInt_Image<int_2>;
 template class NTupInt_Image<int_4>;
 template class NTupInt_Image<r_4>;
+#ifdef SANS_EVOLPLANCK
+template class NOMAdapter_Image<int_2>;
+template class NTupInt_Image<int_2>;
+#endif
 #endif
 
Index: trunk/SophyaPI/PIext/piafitting.cc
===================================================================
--- trunk/SophyaPI/PIext/piafitting.cc	(revision 1104)
+++ trunk/SophyaPI/PIext/piafitting.cc	(revision 1105)
@@ -549,5 +549,5 @@
   else if(mH2) mOpt.xc = (mH2->XMin()+mH2->XMax())/2.;
   else if(mG)  {double mini,maxi; mG->GetMnMx(2,mini,maxi); mOpt.xc=(mini+maxi)/2.;}
-  else if(mIm) {mOpt.xc = mIm->XOrg() * mIm->XPxSize()*(mOpt.i2-mOpt.i1+1)/2.;}
+  else if(mIm) {mOpt.xc = mIm->XOrg() * mIm->XPixSize()*(mOpt.i2-mOpt.i1+1)/2.;}
 }
 if(mOpt.polcy==2 && mNVar>=2) {
@@ -555,5 +555,5 @@
   if(mH2) mOpt.yc = (mH2->YMin()+mH2->YMax())/2.;
   if(mG)  {double mini,maxi; mG->GetMnMx(12,mini,maxi); mOpt.yc=(mini+maxi)/2.;}
-  if(mIm) {mOpt.yc = mIm->YOrg() * mIm->YPxSize()*(mOpt.j2-mOpt.j1+1)/2.;}
+  if(mIm) {mOpt.yc = mIm->YOrg() * mIm->YPixSize()*(mOpt.j2-mOpt.j1+1)/2.;}
 }
 if(mOpt.err_e>0.) mOpt.err_E=-1.;
@@ -601,5 +601,5 @@
      f=(*mH2)(i,j); e=(mH2->HasErrors())?mH2->Error(i,j):1.;}
   else if(mIm)
-    {x=mIm->XOrg()+(i+0.5)*mIm->XPxSize(); y=mIm->YOrg()+(j+0.5)*mIm->YPxSize();
+    {x=mIm->XOrg()+(i+0.5)*mIm->XPixSize(); y=mIm->YOrg()+(j+0.5)*mIm->YPixSize();
      f=mIm->DValue(i,j); e=1.;}
   else if(mG&&mNVar==1) {x= mG->X(i); f=mG->Val(i); e=mG->EVal(i);}
Index: trunk/SophyaPI/PIext/piafitting.h
===================================================================
--- trunk/SophyaPI/PIext/piafitting.h	(revision 1104)
+++ trunk/SophyaPI/PIext/piafitting.h	(revision 1105)
@@ -19,5 +19,4 @@
 class PIStdImgApp;
 class PIAFitterWind;
-class RzImage; //CMV_A_FAIRE class RzImage;
 
 #ifdef SANS_EVOLPLANCK
@@ -26,4 +25,5 @@
 class GeneralFitData;
 class Histo;  class Histo2D;
+class RzImage; 
 #else
 #include "tvector.h"
@@ -32,4 +32,5 @@
 class GeneralFitData;
 class Histo; class Histo2D;
+class RzImage; //CMV_A_VIRER class RzImage
 }
 #endif
Index: trunk/SophyaPI/PIext/piinit.cc
===================================================================
--- trunk/SophyaPI/PIext/piinit.cc	(revision 1104)
+++ trunk/SophyaPI/PIext/piinit.cc	(revision 1105)
@@ -68,9 +68,10 @@
 
   serv->RegisterClass(new Image<uint_2>, new  NOMAdapter_Image<uint_2> );
-  serv->RegisterClass(new Image<int_2>, new  NOMAdapter_Image<int_2> );
   serv->RegisterClass(new Image<int_4>, new  NOMAdapter_Image<int_4> );
   serv->RegisterClass(new Image<r_4>, new  NOMAdapter_Image<r_4> );
  
 #ifdef SANS_EVOLPLANCK
+  serv->RegisterClass(new Image<int_2>, new  NOMAdapter_Image<int_2> );
+
   serv->RegisterClass(new FitsImage<uint_2>, new  NOMAdapter_Image<uint_2> );
   serv->RegisterClass(new FitsImage<int_2>, new  NOMAdapter_Image<int_2> );
Index: trunk/SophyaPI/PIext/servnobjm.cc
===================================================================
--- trunk/SophyaPI/PIext/servnobjm.cc	(revision 1104)
+++ trunk/SophyaPI/PIext/servnobjm.cc	(revision 1105)
@@ -1623,4 +1623,5 @@
 
 // SANS_EVOLPLANCK     Attention !
+#ifdef SANS_EVOLPLANCK
 #include "pclassids.h"
 
@@ -1672,5 +1673,4 @@
   case ClassId_Image + kr_8 : 
     return("ImageR8");
-
   case ClassId_ZFidu : 
     return("ZFidu");
@@ -1690,2 +1690,8 @@
 }  
 
+#else
+char* Services2NObjMgr::PClassIdToClassName(int cid)
+{
+    return("AnyDataObj");
+}
+#endif