Index: trunk/SophyaPI/PI/Makefile
===================================================================
--- trunk/SophyaPI/PI/Makefile	(revision 1111)
+++ trunk/SophyaPI/PI/Makefile	(revision 1117)
@@ -142,13 +142,13 @@
  pifontx.h pifontgen.h
 $(OBJ)piimage.o: piimage.cc piimage.h parradapter.h \
- $(INC)machdefs.h lut.h pisysdep.h \
- pidrawer.h pibwdggen.h piwdgx.h piwdggen.h pimsghandler.h picolist.h \
- picmap.h picmapx.h picmapgen.h pigraphx.h pigraphgen.h pifontx.h \
- pifontgen.h pigraphuc.h pievthandler.h psfile.h pipixmapx.h \
- pipixmapgen.h pibwdgx.h pigraphps.h pistdwdgx.h pistdwdggen.h \
- piwindowx.h piwindowgen.h picontainerx.h picontainergen.h \
- picmapview.h piimgtools.h pioptmenux.h pioptmenugen.h pimenux.h \
- pimenugen.h piapplx.h piapplgen.h pimenubarx.h pimenubargen.h \
- picons.h pidrwtools.h piscdrawwdg.h
+ $(INC)machdefs.h lut.h pisysdep.h pidrawer.h \
+ pibwdggen.h piwdgx.h piwdggen.h pimsghandler.h picolist.h picmap.h \
+ picmapx.h picmapgen.h pigraphx.h pigraphgen.h pifontx.h pifontgen.h \
+ pigraphuc.h pievthandler.h psfile.h pipixmapx.h pipixmapgen.h \
+ pibwdgx.h pigraphps.h pistdwdgx.h pistdwdggen.h piwindowx.h \
+ piwindowgen.h picontainerx.h picontainergen.h picmapview.h \
+ piimgtools.h pioptmenux.h pioptmenugen.h pimenux.h pimenugen.h \
+ piapplx.h piapplgen.h pimenubarx.h pimenubargen.h picons.h \
+ pidrwtools.h piscdrawwdg.h
 $(OBJ)piimgtools.o: piimgtools.cc piimgtools.h pisysdep.h \
  $(INC)machdefs.h pistdwdgx.h pistdwdggen.h \
@@ -184,7 +184,6 @@
  pimsghandler.h picolist.h
 $(OBJ)pimenux.o: pimenux.cc pisysdep.h \
- $(INC)machdefs.h pimenubarx.h \
- pimenubargen.h pimenux.h pimenugen.h piwdgx.h piwdggen.h \
- pimsghandler.h picolist.h
+ $(INC)machdefs.h pimenubarx.h pimenubargen.h \
+ pimenux.h pimenugen.h piwdgx.h piwdggen.h pimsghandler.h picolist.h
 $(OBJ)pimsghandler.o: pimsghandler.cc pimsghandler.h \
  $(INC)machdefs.h
@@ -193,11 +192,10 @@
  piwdgx.h piwdggen.h pimsghandler.h picolist.h
 $(OBJ)pioptmenux.o: pioptmenux.cc pisysdep.h \
- $(INC)machdefs.h pioptmenux.h \
- pioptmenugen.h pimenux.h pimenugen.h piwdgx.h piwdggen.h \
- pimsghandler.h picolist.h pistdwdgx.h pistdwdggen.h piapplx.h \
- piapplgen.h picontainerx.h picontainergen.h pimenubarx.h \
- pimenubargen.h picons.h pibwdgx.h pibwdggen.h picmap.h picmapx.h \
- picmapgen.h pigraphx.h pigraphgen.h pifontx.h pifontgen.h pigraphuc.h \
- pievthandler.h psfile.h pigraphps.h
+ $(INC)machdefs.h pioptmenux.h pioptmenugen.h \
+ pimenux.h pimenugen.h piwdgx.h piwdggen.h pimsghandler.h picolist.h \
+ pistdwdgx.h pistdwdggen.h piapplx.h piapplgen.h picontainerx.h \
+ picontainergen.h pimenubarx.h pimenubargen.h picons.h pibwdgx.h \
+ pibwdggen.h picmap.h picmapx.h picmapgen.h pigraphx.h pigraphgen.h \
+ pifontx.h pifontgen.h pigraphuc.h pievthandler.h psfile.h pigraphps.h
 $(OBJ)piperiodx.o: piperiodx.cc piwdgx.h piwdggen.h \
  $(INC)machdefs.h pimsghandler.h picolist.h \
@@ -268,6 +266,5 @@
  pigraphx.h pigraphgen.h pifontx.h pifontgen.h pigraphuc.h \
  pievthandler.h psfile.h pigraphps.h pixtbase.h
-$(OBJ)psfile.o: psfile.cc psfile.h \
- $(INC)machdefs.h pisysdep.h pifontgen.h \
- pigraphgen.h piwdgx.h piwdggen.h pimsghandler.h picolist.h picmap.h \
- picmapx.h picmapgen.h pifontx.h
+$(OBJ)psfile.o: psfile.cc psfile.h $(INC)machdefs.h \
+ pisysdep.h pifontgen.h pigraphgen.h piwdgx.h piwdggen.h \
+ pimsghandler.h picolist.h picmap.h picmapx.h picmapgen.h pifontx.h
Index: trunk/SophyaPI/PIext/Makefile
===================================================================
--- trunk/SophyaPI/PIext/Makefile	(revision 1111)
+++ trunk/SophyaPI/PIext/Makefile	(revision 1117)
@@ -83,4 +83,5 @@
  $(INC)tarray.h \
  $(INC)basarr.h \
+ $(INC)mutyv.h \
  $(INC)dvlist.h \
  $(INC)ndatablock.h \
@@ -150,39 +151,20 @@
  $(INC)piperiodx.h \
  $(INC)periodic.h \
- $(INC)fitsioserver.h \
- $(INC)tarray.h \
- $(INC)basarr.h \
- $(INC)dvlist.h \
- $(INC)objfio.h \
- $(INC)ndatablock.h \
- $(INC)utilarr.h \
- $(INC)tmatrix.h \
- $(INC)tvector.h \
- $(INC)skymap.h \
- $(INC)spherethetaphi.h \
- $(INC)sphericalmap.h \
- $(INC)smathconst.h \
- $(INC)pixelmap.h \
- $(INC)spherepos.h \
- $(INC)unitvector.h \
- $(INC)vector3d.h \
- $(INC)longlat.h \
- $(INC)utilgeom.h \
- $(INC)spherehealpix.h \
- $(INC)localmap.h \
- $(INC)fiospherethetaphi.h \
- $(INC)fiospherehealpix.h \
- $(INC)fiolocalmap.h \
- $(INC)ntuple.h \
- $(INC)cimage.h \
- $(INC)rzimage.h \
- $(INC)rzvect.h \
- $(INC)perrors.h \
  $(INC)pisurfdr.h pipodrw.h \
  $(INC)histos2.h \
  $(INC)peida.h \
  $(INC)utils.h \
- $(INC)fmath.h \
- $(INC)histos.h pintuple.h pintup3d.h \
+ $(INC)perrors.h \
+ $(INC)fmath.h \
+ $(INC)histos.h \
+ $(INC)objfio.h \
+ $(INC)tvector.h \
+ $(INC)tmatrix.h \
+ $(INC)tarray.h \
+ $(INC)basarr.h \
+ $(INC)mutyv.h \
+ $(INC)dvlist.h \
+ $(INC)ndatablock.h \
+ $(INC)utilarr.h pintuple.h pintup3d.h \
  pigfd1.h $(INC)generaldata.h \
  $(INC)poly.h pigfd2.h
@@ -250,4 +232,5 @@
  $(INC)tarray.h \
  $(INC)basarr.h \
+ $(INC)mutyv.h \
  $(INC)dvlist.h \
  $(INC)ndatablock.h \
@@ -291,4 +274,5 @@
  $(INC)tarray.h \
  $(INC)basarr.h \
+ $(INC)mutyv.h \
  $(INC)dvlist.h \
  $(INC)ndatablock.h \
@@ -312,6 +296,6 @@
  $(INC)piwindowgen.h \
  $(INC)picontainerx.h \
- $(INC)picontainergen.h pipodrw.h \
- servnobjm.h $(INC)pdlmgr.h dlftypes.h
+ $(INC)picontainergen.h pipodrw.h servnobjm.h \
+ $(INC)pdlmgr.h dlftypes.h
 $(OBJ)nomimagadapter.o: nomimagadapter.cc \
  $(INC)machdefs.h nomimagadapter.h \
@@ -341,10 +325,12 @@
  $(INC)ntupintf.h \
  $(INC)cimage.h \
- $(INC)rzimage.h \
- $(INC)rzvect.h \
- $(INC)perrors.h \
- $(INC)datatypes.h \
- $(INC)dvlist.h \
- $(INC)objfio.h pimgadapter.h
+ $(INC)tmatrix.h \
+ $(INC)tarray.h \
+ $(INC)basarr.h \
+ $(INC)mutyv.h \
+ $(INC)dvlist.h \
+ $(INC)objfio.h \
+ $(INC)ndatablock.h \
+ $(INC)utilarr.h pimgadapter.h
 $(OBJ)nomskymapadapter.o: nomskymapadapter.cc \
  $(INC)machdefs.h nomskymapadapter.h \
@@ -376,4 +362,5 @@
  $(INC)tarray.h \
  $(INC)basarr.h \
+ $(INC)mutyv.h \
  $(INC)dvlist.h \
  $(INC)objfio.h \
@@ -429,4 +416,5 @@
  $(INC)tarray.h \
  $(INC)basarr.h \
+ $(INC)mutyv.h \
  $(INC)dvlist.h \
  $(INC)objfio.h \
@@ -441,4 +429,5 @@
  $(INC)basarr.h \
  $(INC)anydataobj.h \
+ $(INC)mutyv.h \
  $(INC)dvlist.h \
  $(INC)objfio.h \
@@ -494,4 +483,5 @@
  $(INC)tarray.h \
  $(INC)basarr.h \
+ $(INC)mutyv.h \
  $(INC)dvlist.h \
  $(INC)ndatablock.h \
@@ -551,7 +541,6 @@
  $(INC)piperiodx.h \
  $(INC)periodic.h
-$(OBJ)piacmd.o: piacmd.cc piacmd.h \
- $(INC)machdefs.h dlftypes.h \
- $(INC)pdlmgr.h basexecut.h \
+$(OBJ)piacmd.o: piacmd.cc piacmd.h $(INC)machdefs.h \
+ dlftypes.h $(INC)pdlmgr.h basexecut.h \
  $(INC)ctimer.h pistdimgapp.h \
  $(INC)pisysdep.h \
@@ -612,4 +601,5 @@
  $(INC)tarray.h \
  $(INC)basarr.h \
+ $(INC)mutyv.h \
  $(INC)dvlist.h \
  $(INC)objfio.h \
@@ -626,4 +616,5 @@
  $(INC)basarr.h \
  $(INC)anydataobj.h \
+ $(INC)mutyv.h \
  $(INC)dvlist.h \
  $(INC)objfio.h \
@@ -643,13 +634,10 @@
  $(INC)ntuple.h \
  $(INC)cimage.h \
- $(INC)rzimage.h \
- $(INC)rzvect.h \
- $(INC)datatypes.h \
  $(INC)histos.h \
  $(INC)histos2.h \
  $(INC)hisprof.h \
  $(INC)objfitter.h piafitting.h \
- $(INC)pdlmgr.h dlftypes.h piacmd.h \
- nobjmgr.h pistdimgapp.h $(INC)pisysdep.h \
+ $(INC)pdlmgr.h dlftypes.h piacmd.h nobjmgr.h \
+ pistdimgapp.h $(INC)pisysdep.h \
  $(INC)piapplx.h \
  $(INC)piapplgen.h \
@@ -718,4 +706,5 @@
  $(INC)tarray.h \
  $(INC)basarr.h \
+ $(INC)mutyv.h \
  $(INC)dvlist.h \
  $(INC)ndatablock.h \
@@ -756,4 +745,5 @@
  $(INC)tarray.h \
  $(INC)basarr.h \
+ $(INC)mutyv.h \
  $(INC)dvlist.h \
  $(INC)ndatablock.h \
@@ -796,4 +786,5 @@
  $(INC)tarray.h \
  $(INC)basarr.h \
+ $(INC)mutyv.h \
  $(INC)dvlist.h \
  $(INC)ndatablock.h \
@@ -863,4 +854,5 @@
  $(INC)tarray.h \
  $(INC)basarr.h \
+ $(INC)mutyv.h \
  $(INC)dvlist.h \
  $(INC)ndatablock.h \
@@ -872,6 +864,6 @@
  $(INC)nbrandom.h \
  $(INC)srandgen.h
-$(OBJ)piinit.o: piinit.cc $(INC)machdefs.h \
- piinit.h $(INC)sambainit.h \
+$(OBJ)piinit.o: piinit.cc $(INC)machdefs.h piinit.h \
+ $(INC)sambainit.h \
  $(INC)skymapinit.h \
  $(INC)sophyainit.h \
@@ -944,4 +936,5 @@
  $(INC)tarray.h \
  $(INC)basarr.h \
+ $(INC)mutyv.h \
  $(INC)dvlist.h \
  $(INC)ndatablock.h \
@@ -953,8 +946,5 @@
  $(INC)generaldata.h \
  $(INC)poly.h nomimagadapter.h \
- $(INC)cimage.h \
- $(INC)rzimage.h \
- $(INC)rzvect.h \
- $(INC)datatypes.h nomtmatvecadapter.h \
+ $(INC)cimage.h nomtmatvecadapter.h \
  nomskymapadapter.h $(INC)pixelmap.h \
  $(INC)spherepos.h \
@@ -1051,4 +1041,5 @@
  $(INC)tarray.h \
  $(INC)basarr.h \
+ $(INC)mutyv.h \
  $(INC)dvlist.h \
  $(INC)ndatablock.h \
@@ -1126,12 +1117,15 @@
  $(INC)psighand.h \
  $(INC)cimage.h \
- $(INC)rzimage.h \
- $(INC)rzvect.h \
- $(INC)datatypes.h \
- $(INC)ppersist.h \
- $(INC)gnumd5.h \
- $(INC)dvlist.h \
- $(INC)objfio.h \
- $(INC)anydataobj.h pistdimgapp.h \
+ $(INC)tmatrix.h \
+ $(INC)tarray.h \
+ $(INC)basarr.h \
+ $(INC)anydataobj.h \
+ $(INC)mutyv.h \
+ $(INC)dvlist.h \
+ $(INC)objfio.h \
+ $(INC)ppersist.h \
+ $(INC)gnumd5.h \
+ $(INC)ndatablock.h \
+ $(INC)utilarr.h pistdimgapp.h \
  $(INC)pisysdep.h \
  $(INC)piapplx.h \
@@ -1190,9 +1184,4 @@
  $(INC)histos.h \
  $(INC)tvector.h \
- $(INC)tmatrix.h \
- $(INC)tarray.h \
- $(INC)basarr.h \
- $(INC)ndatablock.h \
- $(INC)utilarr.h \
  $(INC)piscdrawwdg.h \
  $(INC)piimgtools.h \
@@ -1212,4 +1201,5 @@
  $(INC)basarr.h \
  $(INC)anydataobj.h \
+ $(INC)mutyv.h \
  $(INC)dvlist.h \
  $(INC)objfio.h \
@@ -1283,4 +1273,5 @@
  $(INC)tarray.h \
  $(INC)basarr.h \
+ $(INC)mutyv.h \
  $(INC)dvlist.h \
  $(INC)objfio.h \
@@ -1296,7 +1287,4 @@
  $(INC)ntuple.h \
  $(INC)cimage.h \
- $(INC)rzimage.h \
- $(INC)rzvect.h \
- $(INC)datatypes.h \
  $(INC)histos.h \
  $(INC)histos2.h \
@@ -1304,3 +1292,3 @@
  $(INC)piscdrawwdg.h \
  $(INC)pisurfdr.h pintuple.h pintup3d.h \
- pipodrw.h $(INC)pclassids.h
+ pipodrw.h