Index: trunk/SophyaExt/LinAlg/Makefile
===================================================================
--- trunk/SophyaExt/LinAlg/Makefile	(revision 1117)
+++ trunk/SophyaExt/LinAlg/Makefile	(revision 1118)
@@ -17,4 +17,5 @@
  $(INC)anydataobj.h \
  $(INC)dvlist.h \
+ $(INC)mutyv.h \
  $(INC)objfio.h \
  $(INC)ppersist.h \
Index: trunk/SophyaLib/HiStats/Makefile
===================================================================
--- trunk/SophyaLib/HiStats/Makefile	(revision 1117)
+++ trunk/SophyaLib/HiStats/Makefile	(revision 1118)
@@ -11,7 +11,6 @@
 endif 
  
-$(OBJ)hisprof.o: hisprof.cc \
- $(INC)machdefs.h hisprof.h \
- $(INC)peida.h \
+$(OBJ)hisprof.o: hisprof.cc $(INC)machdefs.h \
+ hisprof.h $(INC)peida.h \
  $(INC)utils.h \
  $(INC)perrors.h \
@@ -30,7 +29,6 @@
  $(INC)ndatablock.h \
  $(INC)utilarr.h histos.h
-$(OBJ)histinit.o: histinit.cc \
- $(INC)machdefs.h histinit.h \
- $(INC)ntoolsinit.h \
+$(OBJ)histinit.o: histinit.cc $(INC)machdefs.h \
+ histinit.h $(INC)ntoolsinit.h \
  $(INC)tarrinit.h \
  $(INC)sophyainit.h histos.h \
@@ -51,9 +49,7 @@
  $(INC)dvlist.h \
  $(INC)ndatablock.h \
- $(INC)utilarr.h histos2.h \
- hisprof.h ntuple.h \
+ $(INC)utilarr.h histos2.h hisprof.h ntuple.h \
  $(INC)ntupintf.h xntuple.h
-$(OBJ)histos.o: histos.cc \
- $(INC)machdefs.h histos.h \
+$(OBJ)histos.o: histos.cc $(INC)machdefs.h histos.h \
  $(INC)objfio.h \
  $(INC)anydataobj.h \
@@ -75,7 +71,6 @@
  $(INC)poly.h \
  $(INC)strutil.h
-$(OBJ)histos2.o: histos2.cc \
- $(INC)machdefs.h histos2.h \
- $(INC)peida.h \
+$(OBJ)histos2.o: histos2.cc $(INC)machdefs.h \
+ histos2.h $(INC)peida.h \
  $(INC)utils.h \
  $(INC)perrors.h \
@@ -94,6 +89,5 @@
  $(INC)ndatablock.h \
  $(INC)utilarr.h
-$(OBJ)ntuple.o: ntuple.cc \
- $(INC)strutil.h \
+$(OBJ)ntuple.o: ntuple.cc $(INC)strutil.h \
  $(INC)perrors.h \
  $(INC)pexceptions.h \
@@ -106,6 +100,5 @@
  $(INC)dvlist.h \
  $(INC)mutyv.h
-$(OBJ)xntuple.o: xntuple.cc \
- $(INC)ppersist.h \
+$(OBJ)xntuple.o: xntuple.cc $(INC)ppersist.h \
  $(INC)machdefs.h \
  $(INC)pexceptions.h \
Index: trunk/SophyaLib/Samba/Makefile
===================================================================
--- trunk/SophyaLib/Samba/Makefile	(revision 1117)
+++ trunk/SophyaLib/Samba/Makefile	(revision 1118)
@@ -24,4 +24,5 @@
  $(INC)tarray.h \
  $(INC)basarr.h \
+ $(INC)mutyv.h \
  $(INC)dvlist.h \
  $(INC)objfio.h \
@@ -45,4 +46,5 @@
  $(INC)tarray.h \
  $(INC)basarr.h \
+ $(INC)mutyv.h \
  $(INC)dvlist.h \
  $(INC)objfio.h \
@@ -68,4 +70,5 @@
  $(INC)objfio.h \
  $(INC)anydataobj.h \
+ $(INC)mutyv.h \
  $(INC)spherepos.h \
  $(INC)unitvector.h \
@@ -93,4 +96,5 @@
  $(INC)objfio.h \
  $(INC)anydataobj.h \
+ $(INC)mutyv.h \
  $(INC)ndatablock.h \
  $(INC)piocmplx.h \
@@ -108,4 +112,5 @@
  $(INC)objfio.h \
  $(INC)anydataobj.h \
+ $(INC)mutyv.h \
  $(INC)spherepos.h \
  $(INC)unitvector.h \
Index: trunk/SophyaLib/SkyMap/Makefile
===================================================================
--- trunk/SophyaLib/SkyMap/Makefile	(revision 1117)
+++ trunk/SophyaLib/SkyMap/Makefile	(revision 1118)
@@ -19,5 +19,6 @@
  $(INC)dvlist.h \
  $(INC)objfio.h \
- $(INC)anydataobj.h spherepos.h unitvector.h \
+ $(INC)anydataobj.h \
+ $(INC)mutyv.h spherepos.h unitvector.h \
  vector3d.h longlat.h utilgeom.h \
  $(INC)tvector.h \
@@ -36,5 +37,6 @@
  $(INC)dvlist.h \
  $(INC)objfio.h \
- $(INC)anydataobj.h spherepos.h unitvector.h \
+ $(INC)anydataobj.h \
+ $(INC)mutyv.h spherepos.h unitvector.h \
  vector3d.h longlat.h utilgeom.h \
  $(INC)tvector.h \
@@ -53,5 +55,6 @@
  $(INC)dvlist.h \
  $(INC)objfio.h \
- $(INC)anydataobj.h spherepos.h unitvector.h \
+ $(INC)anydataobj.h \
+ $(INC)mutyv.h spherepos.h unitvector.h \
  vector3d.h longlat.h utilgeom.h \
  $(INC)tvector.h \
@@ -69,5 +72,6 @@
  $(INC)dvlist.h \
  $(INC)objfio.h \
- $(INC)anydataobj.h spherepos.h unitvector.h \
+ $(INC)anydataobj.h \
+ $(INC)mutyv.h spherepos.h unitvector.h \
  vector3d.h longlat.h utilgeom.h sphericalmap.h \
  $(INC)smathconst.h \
@@ -89,5 +93,6 @@
  $(INC)gnumd5.h \
  $(INC)dvlist.h \
- $(INC)objfio.h spherepos.h unitvector.h \
+ $(INC)objfio.h \
+ $(INC)mutyv.h spherepos.h unitvector.h \
  vector3d.h longlat.h utilgeom.h
 $(OBJ)skymapinit.o: skymapinit.cc $(INC)machdefs.h \
@@ -100,5 +105,6 @@
  $(INC)dvlist.h \
  $(INC)objfio.h \
- $(INC)anydataobj.h spherepos.h unitvector.h \
+ $(INC)anydataobj.h \
+ $(INC)mutyv.h spherepos.h unitvector.h \
  vector3d.h longlat.h utilgeom.h \
  $(INC)tvector.h \
@@ -119,5 +125,6 @@
  sphericalmap.h $(INC)smathconst.h pixelmap.h \
  $(INC)dvlist.h \
- $(INC)objfio.h spherepos.h unitvector.h \
+ $(INC)objfio.h \
+ $(INC)mutyv.h spherepos.h unitvector.h \
  vector3d.h longlat.h utilgeom.h \
  $(INC)tvector.h \
@@ -141,5 +148,6 @@
  $(INC)dvlist.h \
  $(INC)objfio.h \
- $(INC)anydataobj.h spherepos.h unitvector.h \
+ $(INC)anydataobj.h \
+ $(INC)mutyv.h spherepos.h unitvector.h \
  vector3d.h longlat.h utilgeom.h \
  $(INC)tvector.h \