Index: /trunk/SophyaProg/PMixer/Makefile
===================================================================
--- /trunk/SophyaProg/PMixer/Makefile	(revision 1120)
+++ /trunk/SophyaProg/PMixer/Makefile	(revision 1121)
@@ -4,5 +4,5 @@
 ifdef NOSHLIB
 LIBF =  $(LIB)libSysTools.a $(LIB)libNTools.a $(LIB)libSamba.a $(LIB)libSkyMap.a $(LIB)libSkyT.a $(LIB)libFitsIOServer.a
-LIBS = -L$(LIB) -lFitsIOServer -lSamba  -lSkyMap -lSkyT -lHiStats -lNTools -lTArray  -lSysTools -L$(EXTLIBPATH) -lcfitsio -lm
+LIBS = -L$(LIB) -lSysTools -lNTools -lSamba -lSkyMap -lSkyT -lFitsIOServer  -lm
 ifeq ($(CXX),cxx)
 # librairie des instances de templates cxx
@@ -13,5 +13,8 @@
 LIBS = -L$(SLB) -lsophya -lextsophya  -lm
 endif
-
+LIBSORA := $(LIBS)
+ifdef ORACLE_HOME
+LIBSORA := -L$(LIB) -lDb++ $(LIBS) -lErosDb -L$(ORACLE_HOME)/lib -lclntsh
+endif
 LDLIBS := $(LIBS) $(LDLIBS)
 PROGS = $(EXE)skymixer $(EXE)extractRS $(EXE)tgrsr $(EXE)tgsky $(EXE)easyTest $(EXE)Sph2Sph
@@ -59,55 +62,52 @@
  $(INC)basarr.h \
  $(INC)anydataobj.h \
- $(INC)dvlist.h \
- $(INC)objfio.h \
- $(INC)ppersist.h \
- $(INC)pexceptions.h \
- $(INC)gnumd5.h \
- $(INC)ndatablock.h \
- $(INC)utilarr.h \
- $(INC)tvector.h \
- $(INC)fioarr.h \
- $(INC)vector3d.h \
- $(INC)longlat.h \
- $(INC)utilgeom.h \
- $(INC)srandgen.h \
- $(INC)timing.h \
- $(INC)sambainit.h \
- $(INC)skymapinit.h \
- $(INC)sophyainit.h \
- $(INC)ntoolsinit.h \
- $(INC)tarrinit.h \
- $(INC)datacards.h \
- $(INC)fitsioserver.h \
- $(INC)skymap.h \
- $(INC)spherethetaphi.h \
- $(INC)sphericalmap.h \
- $(INC)smathconst.h \
- $(INC)pixelmap.h \
- $(INC)spherepos.h \
- $(INC)unitvector.h \
- $(INC)spherehealpix.h \
- $(INC)localmap.h \
- $(INC)fiospherethetaphi.h \
- $(INC)fiospherehealpix.h \
- $(INC)fiolocalmap.h \
- $(INC)fitsspherehealpix.h \
- $(INC)fitsfile.h \
- $(INC)fitstarray.h \
- $(INC)radspecvector.h \
- $(INC)radspec.h \
- $(INC)specresp.h \
- $(INC)blackbody.h \
- $(INC)convtools.h \
- $(INC)derivblackbody.h \
- $(INC)nupower.h \
- $(INC)squarefilt.h \
- $(INC)trianglefilt.h \
- $(INC)specrespvector.h \
- $(INC)gaussfilt.h \
- $(INC)bruit.h \
- $(INC)mapoperation.h
-$(OBJ)easyTest.o: easyTest.cc \
- $(INC)blackbody.h \
+ $(INC)mutyv.h \
+ $(INC)dvlist.h \
+ $(INC)objfio.h \
+ $(INC)ppersist.h \
+ $(INC)pexceptions.h \
+ $(INC)gnumd5.h \
+ $(INC)ndatablock.h \
+ $(INC)utilarr.h \
+ $(INC)tvector.h \
+ $(INC)fioarr.h \
+ $(INC)vector3d.h \
+ $(INC)longlat.h \
+ $(INC)utilgeom.h \
+ $(INC)srandgen.h \
+ $(INC)timing.h \
+ $(INC)sambainit.h \
+ $(INC)skymapinit.h \
+ $(INC)sophyainit.h \
+ $(INC)ntoolsinit.h \
+ $(INC)tarrinit.h \
+ $(INC)datacards.h \
+ $(INC)ntuple.h \
+ $(INC)ntupintf.h \
+ $(INC)fiospherehealpix.h \
+ $(INC)sphericalmap.h \
+ $(INC)smathconst.h \
+ $(INC)pixelmap.h \
+ $(INC)spherepos.h \
+ $(INC)unitvector.h \
+ $(INC)spherehealpix.h \
+ $(INC)fitsspherehealpix.h \
+ $(INC)fitsfile.h \
+ $(INC)fitstarray.h \
+ $(INC)cimage.h \
+ $(INC)radspecvector.h \
+ $(INC)radspec.h \
+ $(INC)specresp.h \
+ $(INC)blackbody.h \
+ $(INC)convtools.h \
+ $(INC)derivblackbody.h \
+ $(INC)nupower.h \
+ $(INC)squarefilt.h \
+ $(INC)trianglefilt.h \
+ $(INC)specrespvector.h \
+ $(INC)gaussfilt.h \
+ $(INC)bruit.h \
+ $(INC)mapoperation.h
+$(OBJ)easyTest.o: easyTest.cc $(INC)blackbody.h \
  $(INC)radspec.h \
  $(INC)machdefs.h \
@@ -124,4 +124,5 @@
  $(INC)tarray.h \
  $(INC)basarr.h \
+ $(INC)mutyv.h \
  $(INC)dvlist.h \
  $(INC)ndatablock.h \
@@ -137,40 +138,38 @@
  $(INC)basarr.h \
  $(INC)anydataobj.h \
- $(INC)dvlist.h \
- $(INC)objfio.h \
- $(INC)ppersist.h \
- $(INC)pexceptions.h \
- $(INC)gnumd5.h \
- $(INC)ndatablock.h \
- $(INC)utilarr.h \
- $(INC)tvector.h \
- $(INC)fioarr.h \
- $(INC)vector3d.h \
- $(INC)longlat.h \
- $(INC)utilgeom.h \
- $(INC)srandgen.h \
- $(INC)timing.h \
- $(INC)sambainit.h \
- $(INC)skymapinit.h \
- $(INC)sophyainit.h \
- $(INC)ntoolsinit.h \
- $(INC)tarrinit.h \
- $(INC)datacards.h \
- $(INC)fitsioserver.h \
- $(INC)skymap.h \
- $(INC)spherethetaphi.h \
- $(INC)sphericalmap.h \
- $(INC)smathconst.h \
- $(INC)pixelmap.h \
- $(INC)spherepos.h \
- $(INC)unitvector.h \
- $(INC)spherehealpix.h \
- $(INC)localmap.h \
- $(INC)fiospherethetaphi.h \
- $(INC)fiospherehealpix.h \
- $(INC)fiolocalmap.h \
- $(INC)fitsspherehealpix.h \
- $(INC)fitsfile.h \
- $(INC)fitstarray.h \
+ $(INC)mutyv.h \
+ $(INC)dvlist.h \
+ $(INC)objfio.h \
+ $(INC)ppersist.h \
+ $(INC)pexceptions.h \
+ $(INC)gnumd5.h \
+ $(INC)ndatablock.h \
+ $(INC)utilarr.h \
+ $(INC)tvector.h \
+ $(INC)fioarr.h \
+ $(INC)vector3d.h \
+ $(INC)longlat.h \
+ $(INC)utilgeom.h \
+ $(INC)srandgen.h \
+ $(INC)timing.h \
+ $(INC)sambainit.h \
+ $(INC)skymapinit.h \
+ $(INC)sophyainit.h \
+ $(INC)ntoolsinit.h \
+ $(INC)tarrinit.h \
+ $(INC)datacards.h \
+ $(INC)ntuple.h \
+ $(INC)ntupintf.h \
+ $(INC)fiospherehealpix.h \
+ $(INC)sphericalmap.h \
+ $(INC)smathconst.h \
+ $(INC)pixelmap.h \
+ $(INC)spherepos.h \
+ $(INC)unitvector.h \
+ $(INC)spherehealpix.h \
+ $(INC)fitsspherehealpix.h \
+ $(INC)fitsfile.h \
+ $(INC)fitstarray.h \
+ $(INC)cimage.h \
  $(INC)radspecvector.h \
  $(INC)radspec.h \
@@ -192,161 +191,153 @@
  $(INC)basarr.h \
  $(INC)anydataobj.h \
- $(INC)dvlist.h \
- $(INC)objfio.h \
- $(INC)ppersist.h \
- $(INC)pexceptions.h \
- $(INC)gnumd5.h \
- $(INC)ndatablock.h \
- $(INC)utilarr.h \
- $(INC)tvector.h \
- $(INC)fioarr.h \
- $(INC)vector3d.h \
- $(INC)longlat.h \
- $(INC)utilgeom.h \
- $(INC)srandgen.h \
- $(INC)timing.h \
- $(INC)sambainit.h \
- $(INC)skymapinit.h \
- $(INC)sophyainit.h \
- $(INC)ntoolsinit.h \
- $(INC)tarrinit.h \
- $(INC)datacards.h \
- $(INC)fitsioserver.h \
- $(INC)skymap.h \
- $(INC)spherethetaphi.h \
- $(INC)sphericalmap.h \
- $(INC)smathconst.h \
- $(INC)pixelmap.h \
- $(INC)spherepos.h \
- $(INC)unitvector.h \
- $(INC)spherehealpix.h \
- $(INC)localmap.h \
- $(INC)fiospherethetaphi.h \
- $(INC)fiospherehealpix.h \
- $(INC)fiolocalmap.h \
- $(INC)fitsspherehealpix.h \
- $(INC)fitsfile.h \
- $(INC)fitstarray.h \
- $(INC)radspecvector.h \
- $(INC)radspec.h \
- $(INC)specresp.h \
- $(INC)blackbody.h \
- $(INC)convtools.h \
- $(INC)derivblackbody.h \
- $(INC)nupower.h \
- $(INC)squarefilt.h \
- $(INC)trianglefilt.h \
- $(INC)specrespvector.h \
- $(INC)gaussfilt.h \
- $(INC)bruit.h \
- $(INC)mapoperation.h
-$(OBJ)tgrsr.o: tgrsr.cc pmixer.h \
- $(INC)machdefs.h \
- $(INC)tmatrix.h \
- $(INC)tarray.h \
- $(INC)basarr.h \
- $(INC)anydataobj.h \
- $(INC)dvlist.h \
- $(INC)objfio.h \
- $(INC)ppersist.h \
- $(INC)pexceptions.h \
- $(INC)gnumd5.h \
- $(INC)ndatablock.h \
- $(INC)utilarr.h \
- $(INC)tvector.h \
- $(INC)fioarr.h \
- $(INC)vector3d.h \
- $(INC)longlat.h \
- $(INC)utilgeom.h \
- $(INC)srandgen.h \
- $(INC)timing.h \
- $(INC)sambainit.h \
- $(INC)skymapinit.h \
- $(INC)sophyainit.h \
- $(INC)ntoolsinit.h \
- $(INC)tarrinit.h \
- $(INC)datacards.h \
- $(INC)fitsioserver.h \
- $(INC)skymap.h \
- $(INC)spherethetaphi.h \
- $(INC)sphericalmap.h \
- $(INC)smathconst.h \
- $(INC)pixelmap.h \
- $(INC)spherepos.h \
- $(INC)unitvector.h \
- $(INC)spherehealpix.h \
- $(INC)localmap.h \
- $(INC)fiospherethetaphi.h \
- $(INC)fiospherehealpix.h \
- $(INC)fiolocalmap.h \
- $(INC)fitsspherehealpix.h \
- $(INC)fitsfile.h \
- $(INC)fitstarray.h \
- $(INC)radspecvector.h \
- $(INC)radspec.h \
- $(INC)specresp.h \
- $(INC)blackbody.h \
- $(INC)convtools.h \
- $(INC)derivblackbody.h \
- $(INC)nupower.h \
- $(INC)squarefilt.h \
- $(INC)trianglefilt.h \
- $(INC)specrespvector.h \
- $(INC)gaussfilt.h \
- $(INC)bruit.h \
- $(INC)mapoperation.h
-$(OBJ)tgsky.o: tgsky.cc pmixer.h \
- $(INC)machdefs.h \
- $(INC)tmatrix.h \
- $(INC)tarray.h \
- $(INC)basarr.h \
- $(INC)anydataobj.h \
- $(INC)dvlist.h \
- $(INC)objfio.h \
- $(INC)ppersist.h \
- $(INC)pexceptions.h \
- $(INC)gnumd5.h \
- $(INC)ndatablock.h \
- $(INC)utilarr.h \
- $(INC)tvector.h \
- $(INC)fioarr.h \
- $(INC)vector3d.h \
- $(INC)longlat.h \
- $(INC)utilgeom.h \
- $(INC)srandgen.h \
- $(INC)timing.h \
- $(INC)sambainit.h \
- $(INC)skymapinit.h \
- $(INC)sophyainit.h \
- $(INC)ntoolsinit.h \
- $(INC)tarrinit.h \
- $(INC)datacards.h \
- $(INC)fitsioserver.h \
- $(INC)skymap.h \
- $(INC)spherethetaphi.h \
- $(INC)sphericalmap.h \
- $(INC)smathconst.h \
- $(INC)pixelmap.h \
- $(INC)spherepos.h \
- $(INC)unitvector.h \
- $(INC)spherehealpix.h \
- $(INC)localmap.h \
- $(INC)fiospherethetaphi.h \
- $(INC)fiospherehealpix.h \
- $(INC)fiolocalmap.h \
- $(INC)fitsspherehealpix.h \
- $(INC)fitsfile.h \
- $(INC)fitstarray.h \
- $(INC)radspecvector.h \
- $(INC)radspec.h \
- $(INC)specresp.h \
- $(INC)blackbody.h \
- $(INC)convtools.h \
- $(INC)derivblackbody.h \
- $(INC)nupower.h \
- $(INC)squarefilt.h \
- $(INC)trianglefilt.h \
- $(INC)specrespvector.h \
- $(INC)gaussfilt.h \
- $(INC)bruit.h \
- $(INC)mapoperation.h
+ $(INC)mutyv.h \
+ $(INC)dvlist.h \
+ $(INC)objfio.h \
+ $(INC)ppersist.h \
+ $(INC)pexceptions.h \
+ $(INC)gnumd5.h \
+ $(INC)ndatablock.h \
+ $(INC)utilarr.h \
+ $(INC)tvector.h \
+ $(INC)fioarr.h \
+ $(INC)vector3d.h \
+ $(INC)longlat.h \
+ $(INC)utilgeom.h \
+ $(INC)srandgen.h \
+ $(INC)timing.h \
+ $(INC)sambainit.h \
+ $(INC)skymapinit.h \
+ $(INC)sophyainit.h \
+ $(INC)ntoolsinit.h \
+ $(INC)tarrinit.h \
+ $(INC)datacards.h \
+ $(INC)ntuple.h \
+ $(INC)ntupintf.h \
+ $(INC)fiospherehealpix.h \
+ $(INC)sphericalmap.h \
+ $(INC)smathconst.h \
+ $(INC)pixelmap.h \
+ $(INC)spherepos.h \
+ $(INC)unitvector.h \
+ $(INC)spherehealpix.h \
+ $(INC)fitsspherehealpix.h \
+ $(INC)fitsfile.h \
+ $(INC)fitstarray.h \
+ $(INC)cimage.h \
+ $(INC)radspecvector.h \
+ $(INC)radspec.h \
+ $(INC)specresp.h \
+ $(INC)blackbody.h \
+ $(INC)convtools.h \
+ $(INC)derivblackbody.h \
+ $(INC)nupower.h \
+ $(INC)squarefilt.h \
+ $(INC)trianglefilt.h \
+ $(INC)specrespvector.h \
+ $(INC)gaussfilt.h \
+ $(INC)bruit.h \
+ $(INC)mapoperation.h
+$(OBJ)tgrsr.o: tgrsr.cc pmixer.h $(INC)machdefs.h \
+ $(INC)tmatrix.h \
+ $(INC)tarray.h \
+ $(INC)basarr.h \
+ $(INC)anydataobj.h \
+ $(INC)mutyv.h \
+ $(INC)dvlist.h \
+ $(INC)objfio.h \
+ $(INC)ppersist.h \
+ $(INC)pexceptions.h \
+ $(INC)gnumd5.h \
+ $(INC)ndatablock.h \
+ $(INC)utilarr.h \
+ $(INC)tvector.h \
+ $(INC)fioarr.h \
+ $(INC)vector3d.h \
+ $(INC)longlat.h \
+ $(INC)utilgeom.h \
+ $(INC)srandgen.h \
+ $(INC)timing.h \
+ $(INC)sambainit.h \
+ $(INC)skymapinit.h \
+ $(INC)sophyainit.h \
+ $(INC)ntoolsinit.h \
+ $(INC)tarrinit.h \
+ $(INC)datacards.h \
+ $(INC)ntuple.h \
+ $(INC)ntupintf.h \
+ $(INC)fiospherehealpix.h \
+ $(INC)sphericalmap.h \
+ $(INC)smathconst.h \
+ $(INC)pixelmap.h \
+ $(INC)spherepos.h \
+ $(INC)unitvector.h \
+ $(INC)spherehealpix.h \
+ $(INC)fitsspherehealpix.h \
+ $(INC)fitsfile.h \
+ $(INC)fitstarray.h \
+ $(INC)cimage.h \
+ $(INC)radspecvector.h \
+ $(INC)radspec.h \
+ $(INC)specresp.h \
+ $(INC)blackbody.h \
+ $(INC)convtools.h \
+ $(INC)derivblackbody.h \
+ $(INC)nupower.h \
+ $(INC)squarefilt.h \
+ $(INC)trianglefilt.h \
+ $(INC)specrespvector.h \
+ $(INC)gaussfilt.h \
+ $(INC)bruit.h \
+ $(INC)mapoperation.h
+$(OBJ)tgsky.o: tgsky.cc pmixer.h $(INC)machdefs.h \
+ $(INC)tmatrix.h \
+ $(INC)tarray.h \
+ $(INC)basarr.h \
+ $(INC)anydataobj.h \
+ $(INC)mutyv.h \
+ $(INC)dvlist.h \
+ $(INC)objfio.h \
+ $(INC)ppersist.h \
+ $(INC)pexceptions.h \
+ $(INC)gnumd5.h \
+ $(INC)ndatablock.h \
+ $(INC)utilarr.h \
+ $(INC)tvector.h \
+ $(INC)fioarr.h \
+ $(INC)vector3d.h \
+ $(INC)longlat.h \
+ $(INC)utilgeom.h \
+ $(INC)srandgen.h \
+ $(INC)timing.h \
+ $(INC)sambainit.h \
+ $(INC)skymapinit.h \
+ $(INC)sophyainit.h \
+ $(INC)ntoolsinit.h \
+ $(INC)tarrinit.h \
+ $(INC)datacards.h \
+ $(INC)ntuple.h \
+ $(INC)ntupintf.h \
+ $(INC)fiospherehealpix.h \
+ $(INC)sphericalmap.h \
+ $(INC)smathconst.h \
+ $(INC)pixelmap.h \
+ $(INC)spherepos.h \
+ $(INC)unitvector.h \
+ $(INC)spherehealpix.h \
+ $(INC)fitsspherehealpix.h \
+ $(INC)fitsfile.h \
+ $(INC)fitstarray.h \
+ $(INC)cimage.h \
+ $(INC)radspecvector.h \
+ $(INC)radspec.h \
+ $(INC)specresp.h \
+ $(INC)blackbody.h \
+ $(INC)convtools.h \
+ $(INC)derivblackbody.h \
+ $(INC)nupower.h \
+ $(INC)squarefilt.h \
+ $(INC)trianglefilt.h \
+ $(INC)specrespvector.h \
+ $(INC)gaussfilt.h \
+ $(INC)bruit.h \
+ $(INC)mapoperation.h